class EncryptOrganizationSettings < PandaPal::MiscHelper::MigrationClass
  def up
    # don't rerun this if it was already run before we renamed the migration.
    existing_versions = execute ("SELECT * from schema_migrations where version = '30171205183457'")
    if (existing_versions.count > 0)
      execute "DELETE from schema_migrations where version = '30171205183457'"
      return
    end
    rename_column :panda_pal_organizations, :settings, :old_settings
    add_column :panda_pal_organizations, :encrypted_settings, :text
    add_column :panda_pal_organizations, :encrypted_settings_iv, :string
  end

  def down
    rename_column :panda_pal_organizations, :old_settings, :settings
    remove_column :panda_pal_organizations, :encrypted_settings
    remove_column :panda_pal_organizations, :encrypted_settings_iv
  end
end
